<?php

	if(!defined('__IN_SYMPHONY__')) die('<h2>Error</h2><p>You cannot directly access this file</p>');

	Final Class eventShoppingCart extends Event{

		private $field_id;

		private $error = false;
		private $action;
		private $id;
		private $num;
		private $price;

		public static function about(){
					
			return array(
						 'name' => 'Shopping Cart',
						 'author' => array('name' => 'Andrey Lubinov',
										   'website' => 'http://las.com.ua',
										   'email' => 'andrey.lubinov@gmail.com'),
						 'version' => '1.0',
						 'release-date' => '2008-12-12',						 
					);						 
		}

    public static function documentation(){
      return;
    }

		public function load(){
			if(isset($_REQUEST['action']) && !empty($_REQUEST['action'])){
				$this->action = $_REQUEST['action'];
				return $this->__trigger();
			}
		}


		protected function __trigger(){
			if(method_exists($this, $this->action)) {
				$conf = $this->_Parent->Configuration->get('shopping_cart');
				$this->field_id = $conf['field_id'];
				$action = $this->action;
				
				$this->s = &$_SESSION[__SYM_COOKIE_PREFIX_ . 'cart'];
				
				$xml = new XMLelement('cart');
				if(!$result = $this->$action()) {
					$xml->appendChild(new XMLElement('msg', __('Unrecognized error'), array('result' => 'error')));
					return $xml;
				}
				$xml->appendChild($result);
				return $xml;
			}
		}
    

		protected function add(){

			$this->checkRequest();
			if($this->error) return $this->error;

			$this->s[$this->id] = array(
				'num' => $this->s[$this->id]['num'] + $this->num, 
				'sum' => $this->s[$this->id]['sum'] + $this->price
			);

			$msg = new XMLElement('msg', __('Item added to cart'));
			$msg->setAttribute('result', 'added');
			return $msg;
		}
		
    
    protected function recalc(){

			$this->checkRequest();
			if($this->error) return $this->error;

			$this->s[$this->id] = array(
															'num' => $this->num, 
															'sum' => $this->price * $this->num
														);
			$msg = new XMLElement('msg', __('The cart is recalculated'));
			$msg->setAttribute('result', 'recalc');
			return $msg;
		}
		
    
		protected function drop(){

			$this->checkRequest();
			if($this->error) return $this->error;

			$filtered = array();
			foreach($this->s as $k => $v){
				if($k != $this->id){
					$filtered[$k] = $v;
				}
			}
			$_SESSION['sym-cart'] = $filtered;
			$msg = new XMLElement('msg', __('Item is dropped'));
			$msg->setAttribute('result', 'dropped');
			return $msg;
		}


		protected function dropAll(){
			$this->s = NULL;
			$msg = new XMLelement('msg', __('All items are dropped'));
			$msg->setAttribute('result', 'dropall');
			return $msg;
		}


		protected function checkRequest(){
		
			$this->id = $_REQUEST['id'];
			
			if(empty($this->id) || !is_numeric($this->id)){
				$this->error = new XMLelement('msg', __('Item ID is not set or is invalid'));
				$this->error->setAttribute('result', 'error');
				return;
			} 

			if(!$this->price = $this->_Parent->Database->fetchVar("value", 0, "
								SELECT `value` AS `value` 
								FROM `tbl_entries_data_{$this->field_id}` 
								WHERE `entry_id` = {$this->id} 
								LIMIT 1
				")){

				$this->error = new XMLelement('msg', __('Item\'s price is not set or is invalid'));
				$this->error->setAttribute('result', 'error');
				return;
			}
			$this->num = (empty($_REQUEST['num']) || !is_numeric($_REQUEST['num'])) ? 1 : $_REQUEST['num'];
		}


	}