<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:import href="../utilities/master.xsl"/>

<xsl:param name="cart-ds" select="/data/shopping-cart"/>

<xsl:template match="data">
	<h1><xsl:value-of select="$page-title"/></h1>
	<xsl:choose>
		<xsl:when test="$cart-items = 'empty'">
			<p>Cart is empty</p>
		</xsl:when>
		<xsl:otherwise>
			<script src="../../symphony/assets/jquery.js" type="text/javascript"></script>
			<script src="../../extensions/shoppingcart/assets/cart.js" type="text/javascript"></script>
		
			<div id="cartbox">
				<p>
					<xsl:value-of select="$cart-items-num"/>&#160;item<xsl:if test="$cart-items-num &gt; 1">s</xsl:if> at your <a href="{$root}/shop/cart/">Cart</a>. Total: $<span><xsl:value-of
select="$cart-total"/></span>
				</p>
			</div>
		
			<form id="shopping-cart" method="">
				<xsl:apply-templates select="items-at-cart/entry"/>
			</form>
			<h4 id="total">Total: $<span><xsl:value-of select="$cart-total"/></span></h4>
		</xsl:otherwise>
	</xsl:choose>
</xsl:template>

<xsl:template match="items-at-cart/entry">
	<xsl:param name="id" select="@id"/>
	<xsl:param name="item" select="$cart-ds/item[@id = $id]"/>

	<fieldset class="item-at-cart">
		<h4><a href="{$root}/shop/item/{@id}"><xsl:value-of select="title"/></a></h4>
		<p class="iprice">$<strong><xsl:value-of select="price"/></strong> x </p>
		<p><input id="i{@id}" class="inum" type="text" value="{$item/@num}" maxlength="5"/> = </p>
		<p class="isum">$<strong><xsl:value-of select="$item/@sum"/></strong></p>
		<a class="cart" id="i{@id}" href="#drop" title="Drop this item from the cart">Drop</a>
	</fieldset>

</xsl:template>

</xsl:stylesheet>

